Index: evolution-2.28.2/mail/em-folder-view.c
===================================================================
--- evolution-2.28.2.orig/mail/em-folder-view.c
+++ evolution-2.28.2/mail/em-folder-view.c
@@ -1007,9 +1007,15 @@ emfv_popup_mark_unimportant(EPopup *ep,
 static void
 emfv_select_next_message (EMFolderView *emfv, gint count, gboolean always_can_previous)
 {
+	GConfClient *gconf = gconf_client_get_default ();
+	gboolean swap_prev_next = gconf_client_get_bool(gconf, "/apps/evolution/mail/swap_prev_next", NULL);
+
 	if (emfv && count == 1) {
-		if (!message_list_select (emfv->list, MESSAGE_LIST_SELECT_NEXT, 0, 0) && (emfv->hide_deleted || always_can_previous))
-			message_list_select (emfv->list, MESSAGE_LIST_SELECT_PREVIOUS, 0, 0);
+		if (!swap_prev_next) {
+			if (!message_list_select (emfv->list, MESSAGE_LIST_SELECT_NEXT, 0, 0) && (emfv->hide_deleted || always_can_previous))
+				message_list_select (emfv->list, MESSAGE_LIST_SELECT_PREVIOUS, 0, 0);
+		} else if (!message_list_select (emfv->list, MESSAGE_LIST_SELECT_PREVIOUS, 0, 0) && (emfv->hide_deleted || always_can_previous))
+			message_list_select (emfv->list, MESSAGE_LIST_SELECT_NEXT, 0, 0);
 	}
 }
 
Index: evolution-2.28.2/mail/em-mailer-prefs.c
===================================================================
--- evolution-2.28.2.orig/mail/em-mailer-prefs.c
+++ evolution-2.28.2/mail/em-mailer-prefs.c
@@ -1242,6 +1242,11 @@ em_mailer_prefs_construct (EMMailerPrefs
 			    "/apps/evolution/mail/display/enable_vfolders",
 			    G_CALLBACK (toggle_button_toggled));
 
+	prefs->swap_prev_next = GTK_TOGGLE_BUTTON (glade_xml_get_widget (gui, "chkSwapPrevNext"));
+	toggle_button_init (prefs, prefs->swap_prev_next, FALSE,
+			    "/apps/evolution/mail/swap_prev_next",
+			    G_CALLBACK (toggle_button_toggled));
+
 	/* Deleting Mail */
 	prefs->empty_trash = GTK_TOGGLE_BUTTON (glade_xml_get_widget (gui, "chkEmptyTrashOnExit"));
 	prefs->empty_trash_days = GTK_COMBO_BOX (glade_xml_get_widget (gui, "comboboxEmptyTrashDays"));
Index: evolution-2.28.2/mail/em-mailer-prefs.h
===================================================================
--- evolution-2.28.2.orig/mail/em-mailer-prefs.h
+++ evolution-2.28.2/mail/em-mailer-prefs.h
@@ -73,6 +73,7 @@ struct _EMMailerPrefs {
 	GtkToggleButton *empty_trash;
 	GtkComboBox *empty_trash_days;
 	GtkToggleButton *confirm_expunge;
+	GtkToggleButton *swap_prev_next;
 
 	/* HTML Mail tab */
 	GtkFontButton *font_variable;
Index: evolution-2.28.2/mail/evolution-mail.schemas.in
===================================================================
--- evolution-2.28.2.orig/mail/evolution-mail.schemas.in
+++ evolution-2.28.2/mail/evolution-mail.schemas.in
@@ -791,7 +791,7 @@
       </locale>
     </schema>
 
-    <!-- Message Window -->
+   <!-- Message Window -->
 
     <schema>
       <key>/schemas/apps/evolution/mail/message_window/width</key>
@@ -948,7 +948,7 @@
       </locale>
     </schema>
 
-    <schema>
+   <schema>
       <key>/schemas/apps/evolution/mail/prompts/only_bcc</key>
       <applyto>/apps/evolution/mail/prompts/only_bcc</applyto>
       <owner>evolution-mail</owner>
@@ -1440,6 +1440,20 @@
          </long>
       </locale>
     </schema>
+
+     <schema>
+      <key>/schemas/apps/evolution/mail/swap_prev_next</key>
+      <applyto>/apps/evolution/mail/swap_prev_next</applyto>
+      <owner>evolution-mail</owner>
+      <type>bool</type>
+      <default>false</default>
+      <locale name="C">
+         <short>Swap the Prev and Next buttons</short>
+         <long>
+          Swap the action of Previous and Next buttons in the message list.
+         </long>
+      </locale>
+    </schema>
 
     <!-- Others -->
 
Index: evolution-2.28.2/mail/mail-config.glade
===================================================================
--- evolution-2.28.2.orig/mail/mail-config.glade
+++ evolution-2.28.2/mail/mail-config.glade
@@ -5672,6 +5672,25 @@ b</property>
 			      <property name="fill">False</property>
 			    </packing>
 			  </child>
+
+			  <child>
+			    <widget class="GtkCheckButton" id="chkSwapPrevNext">
+			      <property name="visible">True</property>
+			      <property name="can_focus">True</property>
+			      <property name="label" translatable="yes">Move up on message _deletion</property>
+			      <property name="use_underline">True</property>
+			      <property name="relief">GTK_RELIEF_NORMAL</property>
+			      <property name="focus_on_click">True</property>
+			      <property name="active">False</property>
+			      <property name="inconsistent">False</property>
+			      <property name="draw_indicator">True</property>
+			    </widget>
+			    <packing>
+			      <property name="padding">0</property>
+			      <property name="expand">False</property>
+			      <property name="fill">False</property>
+			    </packing>
+			  </child>
 			</widget>
 			<packing>
 			  <property name="left_attach">0</property>